#!/usr/local/bin/perl

#
# Please set Protocols that measure traffics.
#
# port number "nfs" is special...

@displayprotoname=(
	"icmp","www(80)","www-proxy(8000)","ftp-data(20)","nfs(2049)"
	,"X-Window(6000)"
	,"netbios-dgm(138/udp)","ftp(21)","telnet(23)","route(520)","ftp-ctrl(21)"
	,"pop-3(110)","smtp(25)","dns(53)","netbios-ns(137/udp)","netbios-ssn(139/tcp)");
@displayprotoproto=(
	"icmp","tcp","tcp","tcp","udp"
	,"tcp"
	,"udp","tcp","tcp","udp","tcp"
	,"tcp","tcp","tcp","udp","tcp");
@displayprotonum=(
	"0","80","8000","20","2049"
	,"6000"
	,"138","21","23","520","21"
	,"110","25","53","137","139");


#@displayprotoname=(
#	"www(80)","ftp(21)","nfs","telnet(23)","dns(53)","www-proxy(8000)","icmp","netbios-ns(137)","netbios-dgm(138)","netbios-ssn(139)","route(520)");
#@displayprotoproto=(
#	"tcp","tcp","udp","tcp","tcp","tcp","icmp","udp","udp","tcp","udp"); 
#@displayprotonum=(
#	"80",  "21","nfs","23","53","8000","0","137","138","139","520");



$GNUPLOT='gnuplot';
$PPMTOGIF='ppmtogif';

$datadir="data";


# makearray(10,1) => (1,1,1,1,1,1,1,1,1,1,1)
sub makearray
{
    local($size,$element)=@_;
    local($i);
    local(@ret);

    for($i=0;$i<$size;$i++){
	$ret[$i]=$element;
    }
    return @ret;
}

# addarray((1,2,3) , (4,5,6)) = (5,7,9)
sub addarray
{
    local(@array)=@_;
    local(@ret);
    local($len)=scalar(@array) / 2;
    local($i);

    for($i=0;$i<$len;$i++){
	$ret[i]=$array[i] + $array[i+$len];
    }
    return @ret;
}
sub month2day
{
    local($year,$mon) = @_;
    local(@MONTH2DAY) = (31,28,31,30,31,30,31,31,30,31,30,31);
    if(($year%4) == 0 && $mon==2){
	return 29;
    }
    return $MONTH2DAY[$mon-1];
}
sub cleantime
{
    local($year,$mon,$day,$hour) = @_;
    if($hour>=24){
	$hour -= 24;
	$day += 1;
    }elsif($hour<0){
	$hour += 24;
	$day -= 1;
    }
    local($maxday) = &month2day($year,$mon);
    if($day>$maxday){
	$day -= $maxday;
	$mon += 1;
    }elsif($day<1){
	$day+=&month2day($year,((($mon-1)+11)%12)+1);
	$mon-=1;
    }
    if($mon>12){
	$mon-=12;
	$year+=1;
    }elsif($mon<1){
	$mon+=12;
	$year-=1;
    }
    if($year>100){
	$year-=100;
    }
    $hour = sprintf("%02d",$hour);
    $day = sprintf("%02d",$day);
    $mon = sprintf("%02d",$mon);
    $year = sprintf("%02d",$year);
    return ($year,$mon,$day,$hour);
}
sub getnexthourfile
{
    local($year,$mon,$day,$hour) = @_;
    local($file);
    if($hour>=24){
	$hour-=24;
	$file = "../" . getnextday($year,$mon,$day) . "/$hour";
    }else{
	$file = "$hour";
    }
    return $file;
}
########################################################################
# saveall*data
#######################################################################
sub saveallmindata
{
    local($year,$mon,$day,$hour,$min)=@_;
    local($dir)="$datadir/$year/$mon/$day/$hour";
    local($allsize,$allcount)=(0,0);
    local($fname_r)="$dir/${min}.dat";
    local($fname_w)="$dir/${min}.all";
    local(@protocount)=();

    @protocount=&makearray(scalar(@displayprotoname),0);
    print "making file [$fname_r]...\n";
    open(FH_R,"<${fname_r}")||die "$!:can't open [${fname_r}]";
    while(<FH_R>){
	local($time,$ipproto,$fromhost,$fromport,$tohost,$toport,$count,$size)
	    =split(/,/);
	$allsize+=$size;
	$allcount+=$count;
	for($i=0;$i<scalar(@displayprotoname);$i++){
	    if((($fromport eq $displayprotonum[$i]) 
	       || ($toport eq $displayprotonum[$i])) 
		&& ($displayprotoproto[$i] eq $ipproto)){
		$protocount[$i] +=$size;
	    }
	}
    }
    close(FH_R);
    open(FH_W,">${fname_w}")|| die "$!:can't open [${fname_w}]";
    print FH_W "$allsize\t$allcount\t" , join("\t",@protocount) , "\n";
    close(FH_W);
}

sub savealldatasub
{
    local($dir,$file,$rangefrom,$rangeto)=@_;
    local($file_dat)="$dir/$file.dat";
    local($file_all)="$dir/$file.all";
    local(@allsizes,@sizes,$i,$f);
    
    @sizes=@allsizes=&makearray(scalar(@displayprotoname)+2,0);
    
    print "making file [$file_dat]...\n";
    open(FH_W,">$file_dat")|| die "can't open [$file_dat]";
    for($i=$rangefrom;$i<=$rangeto+1;$i++){
	$f=sprintf("$dir/$file/%02d.all",$i);
	if(-r $f){
	    open(FH,"<$f")|| die "$!: can't open [$f]";
	    $_=<FH>;
	    @sizes=split(/\s/,$_);
	    close(FH);
	}else{
	    @sizes=&makearray(scalar(@displayprotoname)+2,0);
	}
	print FH_W "$i\t" , join("\t",@sizes) , "\n";
	local($j);
	for($j=0;$j<scalar(@displayprotoname)+2;$j++){
	    $allsizes[$j]+=$sizes[$j]+0;
	}
    }
    close(FH_W);

    open(FH_W,">$file_all")||die "can't open $file_all";
    print FH_W join("\t",@allsizes) , "\n";
    close(FH_W);    
	    
}
sub saveallhourdata
{
    local($year,$mon,$day,$hour)=@_;
    &savealldatasub("$datadir/$year/$mon/$day",$hour,0,59);
}
sub savealldaydata
{
    local($year,$mon,$day)=@_;
    &savealldatasub("$datadir/$year/$mon",$day,0,23);
}
sub saveallmondata
{
    local($year,$mon)=@_;
    &savealldatasub("$datadir/$year",$mon,1,31);
}
sub saveallyeardata
{
    local($year)=@_;
    &savealldatasub("$datadir",$year,1,12);
    
}

#####################################################################
# make*gif
#####################################################################
sub makegifsub
{
    local($dir,$file,$xrange,$yrange,$xlabel,$ylabel,$xticincr)=@_;
    local($plotcmd,$i);

    $plotcmd="plot $xrange ";
    for($i=1;$i<scalar(@displayprotoname)+3;$i++){
	if($i ==2){
	    next;
	}elsif($i==1){
	    $with="boxes";
	    $title="all";
	}else{
	    $with="linespoints";
	    $title=$displayprotoname[$i-3];
	}
	if($i!=1){$plotcmd .= ",";}
	$plotcmd .=  "\"$dir/$file.dat\" using 1:" . ($i+1) . " title \"$title\" with $with";
    }
    #print "plotcmd=[$plotcmd]\n";

    open(FH_W,">$dir/$file.gp") || die "$!:can't open $dir/$file.gp";
    print FH_W <<"_EOT_";
set terminal pbm color
set autoscale y
#set output "$dir/$file.gif"
# dummy output for set y-max for gnuplot 3.5(no need to gnuplot3.6beta340)
set output "/dev/null"
$plotcmd
set output
set size 1.0,1.0
#set xrange $xrange
set yrange $yrange
set xtics 0,$xticincr
set xlabel "$xlabel"
set ylabel "$ylabel"
$plotcmd
_EOT_
    close(FH_W);

    local($gpcmd)="$GNUPLOT $dir/$file.gp | $PPMTOGIF >$dir/$file.gif.tmp";
    print "plotting ... $dir/$file.dat\n";
    system($gpcmd);
    unlink "$dir/$file.gif";
    link "$dir/$file.gif.tmp","$dir/$file.gif";
    unlink "$dir/$file.gif.tmp";
    unlink "$dir/$file.gp";
    print "ploted\n";
}
sub makehourgif
{
    local($year,$mon,$day,$hour)=@_;
    &makegifsub("$datadir/$year/$mon/$day",$hour,"[0:60]","[0:]","time[minites]","traffic[byte]",10);
}
sub makedaygif
{
    local($year,$mon,$day)=@_;
    &makegifsub("$datadir/$year/$mon",$day,"[0:24]","[0:]","time[hour]","traffic[byte]",1);
}
sub makemongif
{
    local($year,$mon)=@_;
    &makegifsub("$datadir/$year",$mon,"[1:31]","[0:]","time[day]","traffic[byte]",1);
}
sub makeyeargif
{
    local($year)=@_;
    &makegifsub("$datadir",$year,"[1:12]","[0:]","time[month]","traffic[byte]",1);
}
#######################################################################
# make*html
#######################################################################
sub makehourhtml
{
    local($year,$mon,$day,$hour)=@_;
    local($dir)="$datadir/$year/$mon/$day";
    local($file)="$dir/$hour.html";
    local($next)=sprintf("%02d",$hour+1);
    local($prev)=sprintf("%02d",$hour-1);
    local(@times) = &cleantime($year,$mon,$day,$hour+1);
    $next = "../../../" . join("/",splice(@times,0,4));
    local(@times) = &cleantime($year,$mon,$day,$hour-1);
    $prev = "../../../" . join("/",splice(@times,0,4));
    
    open(FH_W,">$file")||die "can't open $file";
    print FH_W <<"_EOT_";
<html>
<head><title>tcpweb(hour:$dir/$hour)</title></head>
<body>
<h1>tcpweb statistics($hour:00 - $hour:59)</h1>
<img src="$hour.gif">
<br>
<a href="$prev.html">Prev Hour</a>
<a href="$next.html">Next Hour</a>
<a href="../$day.html">This Date($dir)</a>
<a href="../../../../index.html">tcpweb Top Page</a>
<br>
</body>
_EOT_
    close(FH_W);
}
sub makedayhtml
{
    local($year,$mon,$day)=@_;
    local($dir)="$datadir/$year/$mon";
    local($file)="$dir/$day.html";
    local($next)=sprintf("%02d",$day+1);
    local($prev)=sprintf("%02d",$day-1);
    local(@times) = &cleantime($year,$mon,$day+1,0);
    $next = "../../" . join("/",splice(@times,0,3));
    local(@times) = &cleantime($year,$mon,$day-1,0);
    $prev = "../../" . join("/",splice(@times,0,3));

    open(FH_W,">$file")||die "can't open $file";
    print FH_W <<"_EOT_";
<html>
<head><title>tcpweb(day:$dir/$day)</title></head>
<body>
<h1>tcpweb statistics($day day)</h1>
<img src="$day.gif">
<br>
<a href="$prev.html">Previous day</a>
<a href="$next.html">Next day</a>
<a href="../$mon.html">This Month($dir)</a>
<a href="../../../index.html">tcpweb Top Page</a>
<br>
<hr>
<ul>
_EOT_
    for($h=0;$h<24;$h++){
	$file=sprintf("${day}/%02d.html",$h);
	print FH_W "<li><a href=\"$file\">$h hour traffic</a>\n";
    }
print FH_W <<"_EOT_";
</ul>
<hr>
</body>
_EOT_
    close(FH_W)
}
sub makemonhtml
{
    local($year,$mon)=@_;
    local($dir)="$datadir/$year";
    local($file)="$dir/$mon.html";
    local($next)=sprintf("%02d",$mon+1);
    local($prev)=sprintf("%02d",$mon-1);
    local($h);
    local(@times) = &cleantime($year,$mon+1,1,0);
    $next = "../" . join("/",splice(@times,0,2));
    local(@times) = &cleantime($year,$mon-1,1,0);
    $prev = "../" . join("/",splice(@times,0,2));

    open(FH_W,">$file")||die "can't open $file";
    print FH_W <<"_EOT_";
<html>
<head><title>tcpweb(month:$dir/$mon)</title></head>
<body>
<h1>tcpweb statistics($mon month)</h1>
<img src="$mon.gif">
<br>
<a href="$prev.html">Previous month</a>
<a href="$next.html">Next month</a>
<a href="../$year.html">This Year($dir)</a>
<a href="../../index.html">tcpweb Top Page</a>
<br>
<hr>
<ul>
_EOT_
    for($i=1;$i<=31;$i++){
	$file=sprintf("${mon}/%02d.html",$i);
	print FH_W "<li><a href=\"$file\">$i day traffic</a>\n";
    }
print FH_W <<"_EOT_";
</ul>
<hr>
</body>
_EOT_
    close(FH_W)
}
sub makeyearhtml
{
    local($year)=@_;
    local($dir)="$datadir";
    local($file)="$dir/$year.html";
    local($next)=sprintf("%02d",$year+1);
    local($prev)=sprintf("%02d",$year-1);
    local($h);
    local(@times) = &cleantime($year+1,1,1,0);
    $next = "" . join("/",splice(@times,0,1));
    local(@times) = &cleantime($year-1,1,1,0);
    $prev = "" . join("/",splice(@times,0,1));

    open(FH_W,">$file")||die "can't open $file";
    print FH_W <<"_EOT_";
<html>
<head><title>tcpweb(month:$dir/$year)</title></head>
<body>
<h1>tcpweb statistics($year year)</h1>
<img src="$year.gif">
<br>
<a href="$prev.html">Previous year</a>
<a href="$next.html">Next year</a>
<a href="../index.html">tcpweb Top Page</a>
<br>
<hr>
<ul>
_EOT_
    for($i=1;$i<=12;$i++){
	$file=sprintf("${year}/%02d.html",$i);
	print FH_W "<li><a href=\"$file\">$i month traffic</a>\n";
    }
print FH_W <<"_EOT_";
</ul>
<hr>
</body>
_EOT_
    close(FH_W)
}


###########################################################
#   makeindexhtml
##########################################################
sub makeindexhtml
{
    local($year,$mon,$day,$hour)=@_;
    local($file)="index.html";
    open(FH_W,">$file")||die "can't open $file";
    print FH_W <<"_EOT_";
<html>
<head><title>tcpweb current status</title></haed>
<body>
<h1>tcpweb Current Traffic Statistics</h1>
<ul>
<li>This Hour($hour:00-$hour:59) Traffic<br>
<a href="$datadir/$year/$mon/$day/$hour.html">
    <img src="$datadir/$year/$mon/$day/$hour.gif"></a>
<li>Today($year/$mon/$day) Traffic<br>
<a href="$datadir/$year/$mon/$day.html"><img src="$datadir/$year/$mon/$day.gif"></a>
<li>This Month($mon month) Traffic<br>
<a href="$datadir/$year/$mon.html"><img src="$datadir/$year/$mon.gif"></a>
<li>This Year($year year) Traffic<br>
<a href="$datadir/$year.html"><img src="$datadir/$year.gif"></a> 
</ul>
<hr>
<address><a href="http://infonet.aist-nara.ac.jp/~tsuneo-y/soft/tcpweb/">tcpweb</a> is made by <a href="mailto:QWF00133\@nifty.ne.jp">Yoshioka Tsuneo</a>
</body>
_EOT_
    close(FH_W);
}

########################################
sub makefiles
{
    &saveallmindata($year2,$mon2,$day2,$hour2,$min2);

    &saveallhourdata($year2,$mon2,$day2,$hour2);
    &makehourgif($year2,$mon2,$day2,$hour2);
    &makehourhtml($year2,$mon2,$day2,$hour2);
    
    &savealldaydata($year2,$mon2,$day2);
    &makedaygif($year2,$mon2,$day2);
    &makedayhtml($year2,$mon2,$day2);

    &saveallmondata($year2,$mon2);
    &makemongif($year2,$mon2);
    &makemonhtml($year2,$mon2);

    &saveallyeardata($year2);
    &makeyeargif($year2);
    &makeyearhtml($year2);

    &makeindexhtml($year2,$mon2,$day2,$hour2); 
}

######################################################################
#        main lootin
#################################################################

$|=1;

# set counting "protocol numbers" from "protocol names"
for($i=0;$i<scalar(@displayprotoname);$i++){
#    @serv=getservbyname($displayprotoname[$i],$displayprotoproto[$i]);
#    if($serv[2] >0){
#	$displayprotonum[$i]=$serv[2];
#    }else{
#	$displayprotonum[$i]=$displayprotoname[$i];
#    }
    print "check protocol $displayprotoname[$i]($displayprotonum[$i])/$displayprotoproto[$i]\n";
}

$time2=0;

mkdir($datadir,0777);
while(<>){
    local($time,$ipproto,$fromhost,$fromport,$tohost,$toport,$count,$size)
	=split(/,/);
    $year2=$year,$mon2=$mon,$day2=$day,$hour2=$hour,$min2=$min;
    if($time =~ /^(\d\d)(\d\d)(\d\d)-(\d\d)(\d\d)$/){
	$year=$1;
	$mon=$2;
	$day=$3;
	$hour=$4;
	$min=$5;
    }
    if($time ne $time2){
	if($time2!=0){
	    close(FH_DAT);
	    &makefiles;
	}
	if($date != $date2){
	    mkdir("$datadir/$date",0777);
	    $date2=$date;
	}
	#if($daytime =~ /^(\d\d)(\d\d)$/){
	#    $hour=$1;
	#    $min=$2;
	#}
	mkdir("$datadir/$year",0777);
	mkdir("$datadir/$year/$mon",0777);
	mkdir("$datadir/$year/$mon/$day",0777);
	mkdir("$datadir/$year/$mon/$day/$hour",0777);
	$fname="$datadir/$year/$mon/$day/$hour/${min}.dat";
	#print "$datadir,$year,$mon,$day,$hour,$min\n";
	print "opening [$fname]...\n";
	open(FH_DAT,">$fname")||die "$!: can't open $fname";
	$time2=$time;
    }
    # print FH_DAT;
    print FH_DAT join(",",$time,$ipproto,$fromhost,$fromport,$tohost,$toport,$count,$size);
}
close(FH_DAT);
&makefiles;
